
# coding: utf-8

# ### Ricapitolazione Lez 4
# - definizione di funzione: parametri formali, parametri attuali, parametri inizializzati
# - sviluppo incrementale
# - costruzione di una libreria
# - liste

# # Lez 5
# 
# Torniamo alle liste.
# 
# La lista è una sequenza ordinata di elementi eterogenei e mutabili!!!
# 
# Creiamo Liste

# In[3]:

["ciao", 2.0, 5, [10, 20]]


# In[5]:

list(range(5))


# In[6]:

list(range(1,5))


# In[7]:

list(range(2,10,2))


# In[10]:

list(range(10,0,-1))


# Per accedere ad un elemento delle lista facciamo uso dell'operatore '[]'

# In[25]:

x = [1,2,3,4,5]
x[0]


# In[12]:

x[-2]


# In[13]:

x[1:3]


# In[14]:

x[2:]


# In[15]:

x[:3]


# Per sapere la lunghezza di una lista uso length. Importante quando si deve ciclare sugni elementi di una lista!!!

# In[16]:

i=0
while i < len(x):
    print(x[i]) 
    i = i + 1 


# L'operatore in serve per vedere se un elemento è in una lista e per ciclare sulla lista con il for

# In[18]:

x


# In[17]:

1 in x


# In[19]:

for i in x:
    print(i)


# Operazioni sulle liste

# In[20]:

[1,2]+[4,5]      # concatenazione


# In[21]:

[1,2]*3          # ripetizione  concatenata


# In[22]:

x


# In[24]:

x[1:3]=[]
x


# In[26]:

x[1:3]=['ciccia','casa']
x


# In[27]:

del x[0]


# In[28]:

x


# In[29]:

s1='casa'
s2='casa'


# In[30]:

id(s1)


# In[31]:

id(s2)


# In[32]:

l1=['casa']
l2=['casa']


# In[33]:

id(l1)


# In[34]:

id(l2)


# In[35]:

l3=l2
id(l3)


# Per clonare una lista e mantenere separata l'originale posso fare così

# In[36]:

l3= l2.copy()              ###  oppure l3=l2[:]
id(l3)


# La modifica della lista clonata non modifica l'originale.
!!!!! I metodi delle liste modificano l'oggetto di partenza, i metodi delle stringhe non modificano la lista stessa !!!!
# In[37]:

l4 = l3.append('casa')  ### modifica l3 ma non restituisce nessun valore


# In[38]:

print(l4)


# In[41]:

l1.append(9)    # ho modificato la lista
l1


# In[40]:

l2


# In[46]:

l1=l1*2         # ho creato una nuova lista


# In[47]:

l1


# In[45]:

l2


# In[48]:

def modifica(l):
    l[0]=99


# In[50]:

modifica(l2)


# In[51]:

l2


# In[52]:

def crea(l):        
    l=[1,2,3]
    return l


# Le funzioni che creano qualcosa chiedono spazio in memoria, in altri linguaggi quando crei qualcosa devi specificarlo con nomi come new o malloc

# In[53]:

x=[3,4,67,88,900,2,1,124,5]


# In[55]:

x.sort()
x


# ### Soluzione esercizio insertionSort

# ### Esercizio
# 
# Crea una funzione che prende in ingresso una stringa e crea una lista ordinata di caratteri distinti

# #### Matrici

# In[56]:

A =[[1,2,3],[4,5,6],[7,8,9]]

for i in range(len(A)):
    for j in range(len(A[0])):
        print(A[i][j], end=' ')
    print()


# In[57]:

len(A[0])


# ### La funzione split 
# è essenziale se dovete analizzare dei testi

# In[59]:

s ='Oggi il sole splende nel cielo. Domani pioverà? Chissà chi può saperlo veramente!'


# In[68]:

print(s.split( ))


# In[70]:

s.split('.')


# In[67]:

x='[1,2,34,5,]'
x.split(',')


# ## File

# I file hanno dei caratteri che formattano il testo, questi caratteri fanno parte del file.
# La riga è l'elemento atomico che noi possiamo gestire in un file. Di solito un file viene letto per riga. I caratteri devono essere codificati.
# Caratteri ASCII 1 byte, UNICODE 1 o 2 o più. In europa molto usato l'"UTF-8", che se codifica caratteri sempre li memorizza con la memoria dell'ASCII.
# Noi useremo encoding="UTF-8", ma non è detto che vi capitano pagine che non si riescano a codificare con l'encoding con UTF-8.
open(file, mode='r', buffering=-1, encoding=None, errors=None, newline=None, closefd=True, opener=None)
# In[71]:

open("Esempi/provaTesto.txt")


# In[72]:

f = open("Esempi/provaTesto.txt")


# In[74]:

s = f.read()
s


# In[ ]:

print(s)


# In[ ]:

f.close()


# In[ ]:

f.read()

!!!Tutto quello che avete imparato sulle liste potete applicarlo sui file!!!
# In[ ]:

'un' in s


# In[ ]:

f = open("Esempi/provaTesto.txt")
f.readline()


# In[ ]:

s2=f.readlines()
s2

Quindi f.read() costruisce una stringa mentre f.readlines() mi da una lista, la scelta dipenderà da quello che dovete fare! Un terzo modo è usare il for
# In[ ]:

# leggo il file per riga usando un ciclo for
f = open("Esempi/provaTesto.txt")
i=0
for riga in f:
    print(i,riga)      
    i=i+1
f.close()


# In[ ]:

f = open("Esempi/provaTesto.txt")
for i in range(5):
    print(i)
    print(f.read(20))
    


# In[ ]:

f.read()


# In[ ]:

f.read()


# In[ ]:

f = open("Esempi/provaTesto.txt")


# In[ ]:

#  funzione che legge per riga un file
def stampa(testo):
    i=0
    for riga in testo:
        print(i,riga)      
        i=i+1


# In[ ]:

stampa(open("Esempi/provaTesto.txt"))


# In[ ]:

stampa([1,'cia',4.3,[3,4,5]])


# Usando read a split posso crearmi una lista in cui ogni elemento della lista è una parola?
# 

# In[ ]:

f = open("Esempi/provaTesto.txt")
s = f.read()
l = s.split()
print(l)


# ### Esercizio
# Crea una funzione che prende in ingresso una file e crea una lista ordinata di caratteri distinti

# In[ ]:



